#
# by Dave Mitchell (davem@magnet.com), 1995
#   
# this code is hereby released into the public domain.
#

from string import splitfields,strip
from regsub import gsub
from pickle import dumps,loads
from urllib import quote, unquote
import types, string

"""
Netscape cookies that act like dictionaries.

Create a new one with cookie.cookie() or create a new one from the existing
cookies with cookie.cookie(cgi.environ['HTTP_COOKIE']). This will fail with
a KeyError from cgi.py if there is no previously existing cookie.

Cookies can also output javascript code to set themselves from within
a server-side include (afaik not otherwise possible from SSIs).

'print x' will by default spit out cookies that expire at the end of the
current session. If you want ones that span-sessions, you use 
print x.output(expires=1) instead.

ex:
>>>import cookie
>>>x=cookie.cookie()
>>>x['dave'] = 'rules'
>>>print x
Set-Cookie: dave=rules; path=/
>>>print x.output(expires=1)
'Set-Cookie: dave=rules; path=/; expires=Saturday, 09-Nov-99 00:01:00 GMT'
>>>x.js_output()
<script language="JavaScript">
<!-- begin hiding
document.cookie = "dave=rules; path=/; expires=Saturday, 09-Nov-99 00:01:00 GMT"
// end hiding -->
</script>

ex: setcookie.py

A cgi example that sets a cookie if there wasn't one already and prints 
any existing ones to the screen.

you can run this at http://roach.magnet.com/python/setcookie.py

import cgi, cookie

def main():
  try:
    c=cookie.cookie(cgi.environ['HTTP_COOKIE'])
  except KeyError:
    c=cookie.cookie()

  if not (c.has_key('dave') and c.has_key('spam')):

# set cookies here because user may already have an Apache cookie			
    c['dave'] = 'rules'
    c['spam'] = 'yummy'

  print "Content-type: text/html"
  print c				# output the cookies to Netscape
  print
  print "Here are your cookies:<br><ul>"

  for key in c.keys():
    print "%s: %s<br>"%(key, c[key])  

if __name__ == '__main__':
  main()

"""

# babelize() and debabelize() are for using arbitrary objects as cookie
# values. Due to the 2k cookie size limit and overhead of large cookies
# being sent back and forth on each visit, I disabled this and now 
# require that any object used as a key must either be a string or have
# the feature that eval(repr(object)) == object
#
# feel free to to play with them if you need -  you'll have to modify
# __getitem__ and __setitem__ to pass values through babelize and debabelize
# instead of using eval(). The gsub() is necessary because linefeeds
# are used by netscape to delimit cookies...

def babelize(str):
  if str is None:
    return dumps(None)
  else:
    try:
      return gsub('\012', '~~', dumps(str))
    except:
      return str

def debabelize(str):
  if str is None:
    return loads(None)
  else:
    try:
      return loads(gsub('~~', '\012', str))	
    except:
      return str

class cookie:
#
  def __init__(self,acookie=None):
    self.NoCookiesError = 'NoCookiesError'
    self.cookies={}
    if acookie:
      self.get(acookie)
#
  def __setitem__(self,key,value):
     try:
       self.cookies[key] = quote(value)
     except SyntaxError:
       self.cookies[key] = quote(repr(value))

# note! this code doesn't allow you to use arbitrary objects as values!
# You have to use something for which eval(repr(object)) == object, such
# as lists and dictionaries, and of course strings.

#
  def __getitem__(self,key):
     try:
       return eval(unquote(self.cookies[key]))
     except SyntaxError:
       return unquote(self.cookies[key])
     except NameError:
       return unquote(self.cookies[key])
     except KeyError:
       return ''
#
  def keys(self):
     return self.cookies.keys()
#
  def has_key(self, key):
     return key in self.cookies.keys()
#
  def output(self, opt='\n', expires=None, header='Set-Cookie: '):
    x = []
    for i in self.cookies.keys():
      if expires:
 	x.append('%s%s=%s; path=/; expires=Saturday, 09-Nov-99 00:01:00 GMT'%\
	    (header, i, self.cookies[i]))
      else:
	x.append('%s%s=%s; path=/'%\
	  (header, i, self.cookies[i]))
    return string.joinfields(x,opt)
#
  def __repr__(self):				# output for a browser
    return self.output('\n') 
#
  def js_output(self):				# output javascript to set
						# the cookies (for ssi's)
    print "<script language=\"JavaScript\">"
    print "<!-- begin hiding"

    for key in self.cookies.keys():
      print """document.cookie = \"%s\""""%\
	"%s=%s; path=/; expires=Saturday, 09-Nov-99 00:01:00 GMT"%\
	  (key, self.cookies[key])

    print "// end hiding -->"
    print "</script>"

  def get(self,rawdata):
    if type(rawdata) == types.StringType:
      try:
        for i in splitfields(rawdata,';'):
          tmp = splitfields(strip(i),'=')
          self.cookies[tmp[0]]=tmp[1]
        return 0
      except:
        return -1				# no cookies were passed
#
    elif type(rawdata) == types.InstanceType:	# merge cookies
      for i in rawdata.cookies.keys():
        self[i] = rawdata[i]
#
  def reset(self):
    try:
      for i in self.cookies.keys():
        print "Set-Cookie: "+i+'='+self[i]+\
		'; expires=Wednesday, 09-Nov-94 00:00:00'
# 				
#  a random old date in the past to expire these cookies
#
    except:
      pass

  def has_key(self, key):
    return self.cookies.has_key(key)


